; bit_flip_assy.a51 	Bit flip, to test standalone micro, running from internal flash ROM
; add ALE assertion (11/13)

    $NOSYMBOLS        ; keeps listing short

; default Ride7 path, Mar. 16
    $INCLUDE (C:\Program Files\Raisonance\Ride\inc\51\Dallas\REG320.INC) 
    $INCLUDE (C:\Program Files\Raisonance\Ride\inc\51\Dallas\vectors320.INC) 

	ORG 0					; tells assembler the address at which to place this code
	
	LJMP START		
    
	ORG 480h				;  ...and here the program starts
	
START:	MOV 0C4h, #04h	; turn on ALE during ROM run (bit 2, ALEON, of PMR register, C4h)
            CLR A			; maximize delays
			MOV R2, A	; roundabout way to clear 2 registers
			MOV R3, A
		
			
FLIPIT:	CPL P1.0		;  flips only LSB (bit 0) of port 3
			LCALL DELAY
			SJMP FLIPIT
            
;---------in case you don't still have that delay routine:
ORG 100h
DELAY:	PUSH PSW				; save registers that'll get messed up
			PUSH ACC
			PUSH B
            MOV A,R2				; get outer-loop delay value
INITINNER:	MOV B,R3			; initialize inner loop counter
INLOOP:	DJNZ B, INLOOP		; count down inner loop, till inner hits zero
			DJNZ ACC,INITINNER	; ...then dec outer, and start inner again.
			POP B  				
			POP ACC
			POP PSW
			RET					; Now back to main program.

			
			END
									
									
